/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package zekkenscribe;

import java.io.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import javax.imageio.*;

/**
 *
 * @author douglas
 */
public class zekkenGraphics extends JPanel {

        //private BufferedImage bi;
        //private new File("zekken.jpg");
        static BufferedImage bi/* = new BufferedImage(this.getWidth(),
                    this.getHeight(), BufferedImage.TYPE_INT_RGB)*/;

        @Override public void paintComponent(Graphics g){
            super.paintComponent(g);

            // Rectangle for background (make white later)
            Rectangle2D.Double zekken = new Rectangle2D.Double(0, 0,
                    this.getWidth(), this.getHeight());
            // Creat bi so we can save later.


            /*BufferedImage */bi = new BufferedImage(this.getWidth(),
                    this.getHeight(), BufferedImage.TYPE_INT_RGB);


            // Do all graphics to bi (later display bi to JPanel)
            Graphics2D g2d1 = bi.createGraphics();
            // Come up with font
            /*final String fontPath = "fonts/sazanami-gothic.ttf";
            InputStream fontstream = zekkenGraphics.class.
                    getResourceAsStream(fontPath);*/
            FontSelector fs = new FontSelector();
            //try {
                Font sazanamiGothic = fs.loadFont(Font.PLAIN, 35);
                    //Font.createFont(Font.TRUETYPE_FONT, fontstream);
                Font latinFont = sazanamiGothic/*.deriveFont(Font.PLAIN, 35)*/;
                FontMetrics latinFontFM = g2d1.getFontMetrics(latinFont);

                //clear(g);

                String dojoName = zekkenGUI.dojoText.getText();
                String nameName = zekkenGUI.nameText.getText();
                String kanaName = zekkenGUI.katakanaText.getText();

                //String whitaker_jp = "\u30A6\u30A4\u30BF\u30AB\u30FC";

                // make it so g2d1 will write the graphics to bi
                //Graphics2D g2d1 = (Graphics2D)g;

                int dojoWidth = latinFontFM.stringWidth(dojoName);
                int dojoPos = (this.getWidth() - dojoWidth)/2;
                int nameWidth = latinFontFM.stringWidth(nameName);
                int namePos = (this.getWidth() - nameWidth)/2;


                g2d1.setColor(Color.white);
                g2d1.fill(zekken);
                g2d1.setColor(Color.black);
                g2d1.setFont(latinFont);
                g2d1.drawString(dojoName, dojoPos, 30); // old x = 20
                drawVertKatakana(kanaName, g2d1, sazanamiGothic);
                g2d1.setFont(latinFont);
                g2d1.drawString(nameName, namePos, this.getHeight() - 20);
                // old x = 20

                g.drawImage(bi, 0, 0, this);
                // draw the contents of bi to the g,
                // the graphics used in paintComponent
            /*}
            catch(FontFormatException e){
                System.out.println(e.getMessage());
            }
            catch(IOException e){
                System.out.println(e.getMessage());
            }*/
            

        }


    static boolean saveZekken(){
        File file = new File(zekkenGUI.directoryPath.getText()+"/"+zekkenGUI.fileNameBox.getText());
        boolean success = true;
            try{
                ImageIO.write(bi, "png", file);
            }catch (IOException e) {
                success = false;
                System.out.println("Image could not be read");
                System.exit(1);
            }
            return success;
    }

    void drawVertKatakana(String kanaName, Graphics2D g, Font kanaFont){
            Font bigKanaFont = kanaFont.deriveFont(Font.PLAIN, 40);
            Font smallKanaFont = kanaFont.deriveFont(Font.PLAIN, 30);
            Font latinFont = kanaFont.deriveFont(Font.PLAIN, 35);
            FontMetrics bigKanaFontFM = g.getFontMetrics(bigKanaFont);
            FontMetrics smallKanaFontFM = g.getFontMetrics(smallKanaFont);
            FontMetrics latinFontFM = g.getFontMetrics(latinFont);
            int kanaInString, underscoreInString=0, index=kanaName.indexOf("_"),
                    kanaDrawn=0;
            while (index != -1){
                underscoreInString++;
                index = kanaName.indexOf("_", index+1);
            }
            kanaInString = kanaName.length()-underscoreInString;
            int kanaTotalHeight;
            if (kanaInString > 6){
                kanaTotalHeight = latinFontFM.getHeight() * 6;
            }
            else {
                kanaTotalHeight = latinFontFM.getHeight() * kanaName.length();
            }
            int xPos = (this.getWidth())/2-(this.getWidth())/20;
            int yPosOrig, yPos;
            yPosOrig = yPos = (this.getHeight() - kanaTotalHeight)/3;
            if (kanaInString>6){
                xPos = 2*this.getWidth()/3;
            }
            for (int i=0; i<=kanaName.length()-1; i++){
                if (kanaDrawn==6){
                    xPos=this.getWidth()/3;
                    yPos=yPosOrig;
                }
                if (i==kanaName.length()-1 &&
                        kanaName.substring(i, i+1).equals("_")){
                    // Do nothing
                }
                else if (kanaName.substring(i, i+1).equals("\u30FC")){
                    int offset = i == 0 ? 
                        -bigKanaFontFM.getHeight() : bigKanaFontFM.getHeight();
                    yPos += offset;
                    g.setFont(bigKanaFont);
                    g.rotate(Math.PI/2);
                    // below, due to rotation, coordinates are (y, -x)
                    g.drawString(kanaName.substring(i, i+1), yPos -
                            bigKanaFontFM.getHeight()/2 -
                            bigKanaFontFM.getHeight()/4, (-1)*xPos);
                    g.rotate((-1)*Math.PI/2);
                }
                else if(kanaName.substring(i, i+1).equals("_")){
                    yPos += smallKanaFontFM.getHeight();
                    g.setFont(smallKanaFont);
                    i++; // no need for the underscore any more
                    g.drawString(kanaName.substring(i, i+1), xPos + 
                            smallKanaFontFM.
                            stringWidth(kanaName.substring(i,i+1))/2, yPos);
                }
                else {
                    yPos += bigKanaFontFM.getHeight();
                    g.setFont(bigKanaFont);
                    g.drawString(kanaName.substring(i, i+1), xPos, yPos);
                }
                kanaDrawn++;
            }
        }
    }
