/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package zekkenscribe;
import java.awt.Font;
import java.io.InputStream;
import java.io.IOException; 
import java.awt.FontFormatException;

/**
 *
 * @author douglas
 */
public class FontSelector {
    public Font loadFont(int style, int size){
        /* this should work so that if the font isn't there,
        it returns the normal font */
        Font kanjiFont;
        final String fontPath = "fonts/sazanami-gothic.ttf";
        InputStream fontstream = zekkenGraphics.class.
                getResourceAsStream(fontPath);
        try {
            Font sazanamiGothic =
                Font.createFont(Font.TRUETYPE_FONT, fontstream);
            kanjiFont = sazanamiGothic.deriveFont(style, size);
            return kanjiFont;
        }
        catch(FontFormatException e){
            kanjiFont = new Font("SansSerif", style, size);
            return kanjiFont;
        }
        catch(IOException e){
            kanjiFont = new Font("SansSerif", style, size);
            return kanjiFont;
        }
}
}
